/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#include "condor_common.h"
#include "resourceGroup.h"

ResourceGroup::
ResourceGroup( )
{
	initialized = false;
}

ResourceGroup::
~ResourceGroup( )
{
}

bool ResourceGroup::
Init( List<ClassAd>& adList )
{
    ClassAd *curr;
	adList.Rewind( );
	while( adList.Next( curr ) ) {
		if( !classads.Append( curr ) ) {
			return false;
		}
	}
	initialized = true;
	return true;
}

bool ResourceGroup::
GetClassAds( List<ClassAd> &newList )
{
	if( !initialized ) {
		return false;
	}

	ClassAd *curr;

	classads.Rewind( );
	while( classads.Next( curr ) ) {
		newList.Append( curr );
	}
	return true;
}

bool ResourceGroup::
GetNumberOfClassAds( int& num )
{
	if( !initialized ) {
		return false;
	}
	num = classads.Number( );
	return true;
}

bool ResourceGroup::
ToString( string& buffer )
{
	if( !initialized ) {
		return false;
	}
	PrettyPrint pp;
	ClassAd* curr;
	classads.Rewind( );
	while( classads.Next( curr ) ) {
		pp.Unparse( buffer, curr );
		buffer += "\n";
	}
	return true;
}
