#include "condor_common.h"
#include "condor_classad_analysis.h"

//void usage( char *myName );

int main ( int argc, char *argv[] )
{
	ClassAdAnalyzer analyzer;
	ClassAdParser parser;
	PrettyPrint pp;
	string buffer = "";
	const int NUM_EXPRS = 10;
	vector< string > rankStrings( NUM_EXPRS );
	vector< ExprTree * > rankExprs( NUM_EXPRS );

		// Real Rank expressions
	rankStrings[0] = "0";
	rankStrings[1] = "( IsCommittedJob is true )";
	rankStrings[2] = "( Owner == \"amir\" || Owner == \"butts\" || Owner == \"glew\" || Owner == \"harit\" || Owner == \"sodani\" || Owner == \"zilles\" )";
	rankStrings[3] = "Owner == \"amir\" || Owner == \"butts\" || Owner == \"glew\" || Owner == \"harit\" || Owner == \"sodani\" || Owner == \"zilles\"";
	rankStrings[4] = "( ( Owner == \"amir\" ) || ( Owner == \"zilles\" ) || ( Owner == \"butts\" ) || ( Owner == \"param\" ) || ( Owner == \"saisanth\" ) ) * 100";
	rankStrings[5] = "( Owner == \"ferris\" && ClusterId == 64430 && ProcId == 0 && Cmd == \"/local.wheel/seymour/twohour\" )";
	rankStrings[6] = "Scheduler is \"DedicatedScheduler@raven.cs.wisc.edu\"";

		// Test expressions
	rankStrings[7] = "( a == 4 ) * ( b < 34 || b > 78 ) * foo + ( bar - 2 ) + 6";
	rankStrings[8] = "attribute";
	rankStrings[9] = "booleanAttr + ( nonBooleanAttr == 20 )";

	for( int i = 0; i < NUM_EXPRS; i++ ) {
		rankExprs[i] = parser.ParseExpression( rankStrings[i] );
		cout << "TEST " << i << endl;
		cout << "------" << endl;
		pp.Unparse( buffer, rankExprs[i] );
		cout << "rankExprs[" << i << "] = " << buffer << endl;
		buffer = "";
		ExprTree *newExpr = analyzer.AddExplicitConditionals( rankExprs[i] );
		if( newExpr == NULL ) {
			cout << "AddExplicitConditionals returned NULL" << endl;
		}
		else {
			pp.Unparse( buffer, newExpr );
			cout << "result = " << buffer << endl;
			cout << endl;
			buffer = "";
		}
	}
}
