#include "condor_common.h"
#include "condor_classad_analysis.h"

//void usage( char *myName );

int main ( int argc, char *argv[] )
{
	ClassAdAnalyzer analyzer;
	ClassAdParser parser;
	PrettyPrint pp;
	string buffer = "";
	string testAdStr = "[ a = 12; b = 5; c = ( d < 5 ) && ( b + e < 6); f = target.g]";
	ClassAd *testAd = parser.ParseClassAd( testAdStr ); 
	ClassAd *newTestAd = analyzer.AddExplicitTargets( testAd );
	cout << "testAd = " << testAdStr << endl;
	pp.Unparse( buffer, newTestAd );
	cout << "newTestAd = " << buffer << endl;
	cout << endl;
	buffer = "";
		// MatchClassAd test

	string jobAdString = "";
	string machineAdString = "";

	jobAdString += "[";
	jobAdString += "Requirements = ( Arch == \"INTEL\" ) && ";
	jobAdString += "( OpSys == \"WINNT\" );";
	jobAdString += "]";

	machineAdString += "[";
	machineAdString += "Arch = \"INTEL\";";
	machineAdString += "OpSys = \"WINNT\";";
	machineAdString += "]";

	ClassAd *jobAd = NULL;
	ClassAd *machineAd = NULL;
	jobAd = parser.ParseClassAd( jobAdString );
	machineAd = parser.ParseClassAd( machineAdString );
	ClassAd *newJobAd = NULL;
	ClassAd *newMachineAd = NULL;
	bool match = false;
	MatchClassAd mad;
	newJobAd = analyzer.AddExplicitTargets( jobAd );
	newMachineAd = analyzer.AddExplicitTargets( machineAd );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
	cout << "ReplaceLeftAd( jobAd )" << endl;

	mad.ReplaceLeftAd( jobAd );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
	cout << "ReplaceRightAd( machineAd )" << endl;

	mad.ReplaceRightAd( machineAd );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";

	mad.EvaluateAttrBool( "rightMatchesLeft", match );
	if( match ) {
		cout << "MatchClassAd matches" << endl;
	}
	else {
		cout << "MatchClassAd doesn't match" << endl;
	}

	cout << "RemoveLeftAd( )" << endl;

	mad.RemoveLeftAd( );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
	cout << "RemoveRightAd( )" << endl;

	mad.RemoveRightAd( );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";

	cout << "----------------------------------------" << endl;

	match = false;

	cout << "ReplaceLeftAd( newJobAd )" << endl;

	mad.ReplaceLeftAd( newJobAd );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
	cout << "ReplaceRightAd( newMachineAd )" << endl;

	mad.ReplaceRightAd( newMachineAd );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";

	mad.EvaluateAttrBool( "rightMatchesLeft", match );
	if( match ) {
		cout << "MatchClassAd + target matches" << endl;
	}
	else {
		cout << "MatchClassAd + target doesn't match" << endl;
	}

	cout << "RemoveLeftAd( )" << endl;

	mad.RemoveLeftAd( );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
	cout << "RemoveRightAd( )" << endl;

	mad.RemoveRightAd( );

	pp.Unparse( buffer, &mad );
	cout << "mad = " << buffer << endl;
	buffer = "";
}

