#include "condor_common.h"
#include "condor_classad_analysis.h"

//void usage( char *myName );



int main ( int argc, char *argv[] )
{
	int numCols = 4;
	int numRows = 4;
	BoolValue bvals[4][4] = { { FALSE_VALUE, 
								TRUE_VALUE, 
								TRUE_VALUE,
								FALSE_VALUE },
							  { TRUE_VALUE, 
								FALSE_VALUE, 
								FALSE_VALUE, 
								FALSE_VALUE },
							  { FALSE_VALUE, 
								TRUE_VALUE, 
								FALSE_VALUE, 
								FALSE_VALUE },
							  { FALSE_VALUE, 
								FALSE_VALUE, 
								FALSE_VALUE, 
								TRUE_VALUE } };

	BoolTable bt;
	bt.Init( numCols, numRows );
	for( int col = 0; col < numCols; col++ ) {
		for( int row = 0; row < numRows; row++ ) {
			bt.SetValue( col, row, bvals[col][row] );
		}
	}

	string buffer;
	bt.ToString( buffer );
	cout << "bt = "  << buffer << endl;
	cout << endl;
	buffer = "";

	List< BoolVector > maxTrueList;
	List< BoolVector > minFalseList;

	if( !bt.GenerateMaximalTrueBVList( maxTrueList ) ) {
		cerr << "error in GMTBVL" << endl;
		exit( 1 );
	}

	if( !bt.GenerateMinimalFalseBVList( minFalseList ) ) {
		cerr << "error in GMFBVL" << endl;
		exit( 1 );
	}

	BoolVector *currentBV = NULL;

	maxTrueList.Rewind( );
	cout << "maxTrueList = " << endl;
	while( maxTrueList.Next( currentBV ) ) {
		currentBV->ToString( buffer );
		cout << "  " << buffer << endl;
		buffer = "";
	}
	cout << endl;

	minFalseList.Rewind( );
	cout << "minFalseList = " << endl;
	while( minFalseList.Next( currentBV ) ) {
		currentBV->ToString( buffer );
		cout << "  " << buffer << endl;
		buffer = "";
	}
	cout << endl;
}	
