#include "condor_common.h"
#include "condor_classad.h"

//void usage( char *myName );

int main ( int argc, char *argv[] )
{
	ClassAdParser parser;
	PrettyPrint pp;
	string buffer = "";
	string oldClassAdNoVersion = "[Requirements = x == 5; y = \"foo\"]";
	string oldClassAdVersion = "[ClassAdVersion = 0; Requirements = x == 5; y = \"foo\"]";
	string newClassAd = "[ClassAdVersion = 1; Requirements = x == 5; y = \"foo\"]";

	ClassAd *oldAdNV1, *oldAdNV2, *oldAdV1, *oldAdV2, *newAd1, *newAd2;
	oldAdNV1 = parser.ParseClassAd( oldClassAdNoVersion );
	oldAdNV2 = parser.ParseClassAd( oldClassAdNoVersion );
	oldAdV1 = parser.ParseClassAd( oldClassAdVersion );
	oldAdV2 = parser.ParseClassAd( oldClassAdVersion );
	newAd1 = parser.ParseClassAd( newClassAd );
	newAd2 = parser.ParseClassAd( newClassAd );

	pp.Unparse( buffer, oldAdNV1 );
	cout << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, oldAdNV2 );
	cout << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, oldAdV1 );
	cout << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, oldAdV2 );
	cout << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, newAd1 );
	cout << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, newAd2 );
	cout << buffer << endl;
	buffer = "";

		// empty	empty
	MatchClassAd mad;
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldnv	empty
	mad.ReplaceLeftAd( oldAdNV1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldnv	oldv
	mad.ReplaceRightAd( oldAdV1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// empty	oldv
	mad.RemoveLeftAd( );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// new		oldv
	mad.ReplaceLeftAd( newAd1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// new		empty
	mad.RemoveRightAd( );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// new		new
	mad.ReplaceRightAd( newAd2 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// empty	new
	mad.RemoveLeftAd( );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldv		new
	mad.ReplaceLeftAd( oldAdV1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldv		empty
	mad.RemoveRightAd( );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldv		oldnv
	mad.ReplaceRightAd( oldAdNV2 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// empty	oldnv
	mad.RemoveLeftAd( );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldnv	oldnv
	mad.ReplaceLeftAd( oldAdNV1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// new		oldnv
	mad.RemoveLeftAd( );
	mad.ReplaceLeftAd( newAd1 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";

		// oldv		oldv
	mad.RemoveLeftAd( );
	mad.RemoveRightAd( );
	mad.ReplaceLeftAd( oldAdV1 );
	mad.ReplaceRightAd( oldAdV2 );
	pp.Unparse( buffer, &mad );
	cout << buffer << endl;
	buffer = "";
}
