#include "condor_common.h"
#include "condor_classad.h"

bool match( ClassAd *, ClassAd * );

int main ( int argc, char *argv[] )
{
	ClassAdParser parser;
	PrettyPrint pp;
	string buffer = "";
	string adLString = "[ Attr = 23; Requirements = other.Attr == 12 ]";
	string adRString = "[ Attr = 12; Requirements = other.Attr == 23 ]";

	ClassAd *adL = parser.ParseClassAd( adLString );
	ClassAd *adR = parser.ParseClassAd( adRString );

	pp.Unparse( buffer, adL );
	cout << "adL = " << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, adR );
	cout << "adR = " << buffer << endl;
	buffer = "";

	bool matches = match( adL, adR );

	if( matches ) {
		cout << "The ClassAds match" << endl;
	}

	pp.Unparse( buffer, adL );
	cout << "adL = " << buffer << endl;
	buffer = "";

	pp.Unparse( buffer, adR );
	cout << "adR = " << buffer << endl;
	buffer = "";

}

bool match( ClassAd *left, ClassAd *right ) {
	MatchClassAd mad;
	mad.ReplaceLeftAd( left );
	mad.ReplaceRightAd( right );
	bool matches;
	if( mad.EvaluateAttrBool( "symmetricMatch", matches ) ) {
		mad.RemoveLeftAd( );
		mad.RemoveRightAd( );
		return matches;
	}
	else {
		mad.RemoveLeftAd( );
		mad.RemoveRightAd( );
		return false;
	}
}
	
