#include "condor_common.h"
#include "../condor_daemon_core.V6/condor_daemon_core.h"
#include "condor_debug.h"
#include "condor_config.h"
#include "cluster_server.h"


char*          mySubSystem = "CLUSTER"; // used by Daemon Core
ClusterServer* ct_server;


int main_pre_dc_init( int argc, char* argv[] ) {
	return TRUE;
}


int
main_init( int argc, char *argv[] )
{
	//set_debug_flags("D_FULLDEBUG");
	//set_debug_flags("D_SECURITY");

	dprintf(D_FULLDEBUG, "main_init() called\n");
	
	ct_server = new ClusterServer();

	if( !ct_server ) {
		dprintf(D_ALWAYS, "Error creating cluster server!\n");
		return FALSE;
	}

	ct_server->registerTmrs();
	ct_server->registerCmds();

	return TRUE;
}


int
main_config( bool is_full )
{
	dprintf(D_ALWAYS, "Reconfiguring ...\n");
	delete ct_server;

		// the constructor will reread the config file params
	ct_server = new ClusterServer();
	
	if( !ct_server ) {
		dprintf(D_ALWAYS, "Error creating cluster server!\n");
		return FALSE;
	}

	ct_server->registerTmrs();

	return TRUE;
}


int
main_shutdown_fast()
{
	dprintf(D_FULLDEBUG, "Shutting down fast ...\n");
	delete ct_server;
	DC_Exit(0);
	return TRUE;	// to satisfy c++
}


int
main_shutdown_graceful()
{
	dprintf(D_FULLDEBUG, "Shutting down gracefully ...\n");
	delete ct_server;
	DC_Exit(0);
	return TRUE;	// to satisfy c++
}
