#include "srbClient.h"
#include "srb_util.h"

extern void write_log_basic(char *request_id, char *targetfilename, char *logfilename, char *status);

char request_id[MAXSTR];

/* ============================================================================
 * Transfer a NEST file directly to SRB
 * ==========================================================================*/
int transfer_from_NEST_to_SRB(char *filename, char *logfilename)
{
/*
    srbConn *conn;
    int i, j, status;
    int out_fd, nbytes;
    char *buf;
    char location[MAXSTR];
    NestConnection nest_con;
    long filesize, nfilesize;
    int bytes_read;
    int ret = REQEX_ERROR;
    float nestfreespace;
    srbResult *res;
    mdasC_sql_result_struct *myresult;
    char qval[MAX_DCS_NUM][MAX_TOKEN];
    int selval[MAX_DCS_NUM];

    //start transfer
    buf = (char*)malloc(sizeof(char) * BUF_SIZE);
    fprintf(stdout, "Transfering file:%s to SRB..\n", filename);
    
    //connect to SRB server
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }
    
    //open the output file 
    out_fd = srbObjCreate (conn, MDAS_CATALOG, filename, DATATYPE, 
			   RESOURCE, COLLECTION, NULL, 0);
    if (out_fd < 0)  { //error
      fprintf(stderr, "can't create srb obj\"%s\"\n", filename);
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      return REQEX_ERROR;
    }
    
    //open connection to NEST
    ReqEx_OpenNestConnection(&nest_con, NEST_HOST);

    //get the filesize info
    ReqEx_NestFilesize(&filesize, filename, nest_con);

    //transfer file
    ReqEx_ReadNestBytes(nest_con, filename, 0, buf, BUF_SIZE, &bytes_read);
    i =1;
    while (bytes_read > 0){
      srbObjWrite (conn, out_fd, buf,bytes_read);
      ReqEx_ReadNestBytes(nest_con, filename, i*BUF_SIZE , buf, BUF_SIZE, &bytes_read);
    }
    
    ReqEx_CloseNestConnection(nest_con);
    srbObjClose (conn, out_fd);
    clFinish(conn);

    //open connection again
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      clFinish(conn);
      free(buf);
      return REQEX_ERROR;
    }
   

    //Query the new filesize:------

    //initialize query array
    for (i = 0; i < MAX_DCS_NUM; i++) {
      selval[i] = 0;
      snprintf(qval[i],MAX_TOKEN,"");
    }
    
    //define the query
    snprintf(qval[DATA_NAME],MAX_TOKEN," = '%s'",filename);
    selval[SIZE]=1;
    selval[DATA_GRP_NAME] = 1;
    selval[DATA_REPL_ENUM] = 1;
    selval[PATH_NAME] = 1;    
    selval[RSRC_ADDR_NETPREFIX] = 1;  

    //execute the query
    myresult = malloc (sizeof (mdasC_sql_result_struct));
    status = srbGetDataDirInfo(conn, 0, qval, selval, myresult,  ROWS_WANTED);
    if (status < 0){
      fprintf(stderr, "can't srbGetDataDirInfo. status = %d.\n", status);
      free(myresult);
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }
    nfilesize = atol(get_from_result_struct(myresult,"data_size"));
    snprintf( location, MAXSTR,get_from_result_struct( myresult, "netprefix" ));
    
    printf ("file:%s transfered to SRB, size:%d\n",filename,nfilesize);
    if (filesize == nfilesize){
      write_log_basic(request_id, filename, logfilename, "stage_out_completed");
    }
    
    //    srbObjClose (conn, out_fd);
    free(myresult);
    free(buf);
    clFinish(conn);

*/
}



/* ============================================================================
 * Transfer an SRB file directly to NEST
 * ==========================================================================*/
int transfer_from_SRB_to_NEST(char *filename, char *logfilename, long filesize)
{
/*

    srbConn *conn;
    int i,j;
    int status;
    int in_fd, nbytes;
    char *buf;
    NestConnection nest_con;
    long nfilesize;
    int ret = REQEX_ERROR;
    float nestfreespace;

    //start transfer
    buf = (char*)malloc(sizeof(char) * BUF_SIZE);
    fprintf(stdout, "Transfering file:%s to NEST ..\n", filename);
    
    //connect to SRB server
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }

    //try until the file is successfuly transfered to NEST
    do{ 
      //open the input file 
      in_fd = srbObjOpen (conn, filename, O_RDONLY, COLLECTION);
      if (in_fd < 0)  { //error
	  fprintf(stderr, "can't open obj\"%s\"\n", filename);
	  free(buf);
	  return REQEX_ERROR;
      }

      //open connection to NEST
      ReqEx_OpenNestConnection(&nest_con, NEST_HOST);

      i=0;
      while ((nbytes = srbObjRead (conn, in_fd, buf, BUF_SIZE)) > 0) {
	status = ReqEx_WriteNestBytes(nest_con, 
				      filename, i*BUF_SIZE, buf, nbytes, 1);
	if (status != NEST_SUCCESS) break;
	i++;
      }
      
      status = ReqEx_NestFilesize ( &nfilesize, filename, nest_con );
      if (status != NEST_SUCCESS) {
	fprintf(stdout,"inside ..\n");
	nfilesize = 0;
      }
    }while (filesize != nfilesize); //check filesize
    
    srbObjClose (conn, in_fd);
    clFinish(conn);
    
    //final check
    nfilesize = 0;
    status = ReqEx_NestFilesize ( &nfilesize, filename, nest_con );
    ReqEx_CloseNestConnection(nest_con);

    if (status == NEST_SUCCESS && filesize == nfilesize) 
      ret =  REQEX_SUCCESS;
    else  {free(buf);return REQEX_ERROR;}

    //in case of success:
    if (ret == REQEX_SUCCESS)
      write_log_basic(request_id, filename,logfilename,"transfered");

    free(buf);
    return ret;
*/
}


/* ============================================================================
 * Transfer a file from local disk to SRB
 * ==========================================================================*/

int transfer_to_SRB(char *filename, char *logfilename)
{
    srbConn *conn;
    int i, j, status;
    int out_fd, in_fd, nbytes;
    char *buf;
    char location[MAXSTR], inputfilename[MAXSTR];
    long filesize, nfilesize;
    int bytes_read;
    int ret = REQEX_ERROR;
    srbResult *res;
    mdasC_sql_result_struct *myresult;
    char qval[MAX_DCS_NUM][MAX_TOKEN];
    int selval[MAX_DCS_NUM];
    struct stat filestat;

    //start transfer
    buf = (char*)malloc(sizeof(char) * BUF_SIZE);
    fprintf(stdout, "Transfering file:%s to SRB..\n", filename);
    
    //connect to SRB server
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }
    
    //open the output file 
    out_fd = srbObjCreate (conn, MDAS_CATALOG, filename, DATATYPE, 
			   RESOURCE, COLLECTION, NULL, 0);
    if (out_fd < 0)  { //error
      fprintf(stderr, "can't create srb obj\"%s\"\n", filename);
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      return REQEX_ERROR;
    }
    

    //get the filesize info
    sprintf(inputfilename, "%s/%s", SHARED_NEST_SPACE, filename);
    if (!lstat(inputfilename,&filestat))  //if file exists
      filesize = filestat.st_size;
    
    //open the input file for reading
    in_fd = open(inputfilename, O_RDONLY);
    if (in_fd < 0){
      fprintf(stdout,"Error in opening file : %s\n",inputfilename);
      return REQEX_ERROR;
    }


    //transfer file
    while ( (bytes_read = read(in_fd, buf, BUF_SIZE)) > 0){
      srbObjWrite (conn, out_fd, buf, bytes_read);
    }
    
    srbObjClose (conn, out_fd);
    clFinish(conn);

    //open connection again
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      clFinish(conn);
      free(buf);
      return REQEX_ERROR;
    }
   

    //Query the new filesize:------

    //initialize query array
    for (i = 0; i < MAX_DCS_NUM; i++) {
      selval[i] = 0;
      snprintf(qval[i],MAX_TOKEN,"");
    }
    
    //define the query
    snprintf(qval[DATA_NAME],MAX_TOKEN," = '%s'",filename);
    selval[SIZE]=1;
    selval[DATA_GRP_NAME] = 1;
    selval[DATA_REPL_ENUM] = 1;
    selval[PATH_NAME] = 1;    
    selval[RSRC_ADDR_NETPREFIX] = 1;  

    //execute the query
    myresult = malloc (sizeof (mdasC_sql_result_struct));
    status = srbGetDataDirInfo(conn, 0, qval, selval, myresult,  ROWS_WANTED);
    if (status < 0){
      fprintf(stderr, "can't srbGetDataDirInfo. status = %d.\n", status);
      free(myresult);
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }
    nfilesize = atol(get_from_result_struct(myresult,"data_size"));
    snprintf( location, MAXSTR,get_from_result_struct( myresult, "netprefix" ));
    
    printf ("file:%s transfered to SRB, size:%d\n",filename,nfilesize);
    if (filesize == nfilesize){
      write_log_basic(request_id, filename, logfilename, "stage_out_completed");
    }
    
    //    srbObjClose (conn, out_fd);
    free(myresult);
    free(buf);
    clFinish(conn);
}



/* ============================================================================
 * Transfer an SRB file to local disk
 * ==========================================================================*/
int transfer_from_SRB(char *filename, char *logfilename, long filesize)
{
    int i,j;
    int status;
    int in_fd, out_fd, nbytes;
    char *buf, outfilename[MAXSTR];
    long nfilesize = 0;
    int ret = REQEX_ERROR;
    struct stat filestat;
    srbConn *conn;

    //start transfer
    buf = (char*)malloc(sizeof(char) * BUF_SIZE);
    fprintf(stdout, "Transfering file:%s to local disk ..\n", filename);
    
    //connect to SRB server
    conn = clConnect (HOST_ADDR, SRB_PORT, srbAuth);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
      fprintf(stderr,"Connection failed.\n");
      fprintf(stderr,"%s",clErrorMessage(conn));
      free(buf);
      clFinish(conn);
      return REQEX_ERROR;
    }
    
    //open the input file 
    in_fd = srbObjOpen (conn, filename, O_RDONLY, COLLECTION);
    if (in_fd < 0)  { //error
      fprintf(stderr, "can't open obj\"%s\"\n", filename);
      free(buf);
      return REQEX_ERROR;
    }

    sprintf(outfilename, "%s/%s", SHARED_NEST_SPACE, filename);
    if (!lstat(outfilename,&filestat)) //if file exists unlink
      unlink(outfilename);	
    //create and open file for writing
    out_fd = open(outfilename, O_WRONLY | O_CREAT);
    if (out_fd < 0){
      printf("Error in creating file : %s\n",outfilename);
      return REQEX_ERROR;
    }

    while ((nbytes = srbObjRead (conn, in_fd, buf, BUF_SIZE)) > 0) {
      status = write(out_fd, buf, nbytes);
      if (status != nbytes){
	printf("Error in writing file: %s\n",outfilename);
	return REQEX_ERROR;
      }
    }
    
    close(in_fd);
    close(out_fd);

    if (!lstat(outfilename,&filestat))  //if file exists
      nfilesize = filestat.st_size;

    //final check and cleanup
    free(buf);
    if (filesize == nfilesize){
      write_log_basic(request_id, filename,logfilename,"transfered");      
      return REQEX_SUCCESS;
    }
    else 
      return REQEX_ERROR;
}
//----------------------- MAIN BODY --------------------------------------
main(int argc, char **argv  )
{
  
  char filename[MAXSTR], logfilename[MAXSTR];
  long filesize;
 
  printf("%s TRANSFER\n",argv[1]); //in-> from SRB, out-> to SRB
  
  strcpy(filename, argv[2]);
  strcpy(logfilename, argv[3]);
  filesize = atol(argv[4]);
  strcpy(request_id, argv[5]);

  if (!strcmp(argv[1], "IN")){
    if (storage_type == STORE_TO_DISK)
      transfer_from_SRB(filename, logfilename, filesize);
    else if (storage_type == STORE_TO_NEST)
      transfer_from_SRB_to_NEST(filename, logfilename, filesize);
  }
  else if (!strcmp(argv[1], "OUT")){
    if (storage_type == STORE_TO_DISK)
      ;//transfer_to_SRB(filename, logfilename);
    else if (storage_type == STORE_TO_NEST)
      transfer_from_NEST_to_SRB(filename, logfilename);
  }
}


