#include <errno.h>
#include <sys/types.h>
#include <stdio.h>
#include "ftp_lite.h"
#include "constants.h"

extern void write_log_basic(char *request_id, char *targetfilename, char *logfilename, char *status);

main(int argc, char *argv[])
{
  char source_host[MAXSTR], target_host[MAXSTR];
  char source_file[MAXSTR], target_file[MAXSTR], log_message[MAXSTR];
  char fname[MAXSTR], logfilename[MAXSTR], request_id[MAXSTR];
  struct ftp_lite_server *source = 0, *target = 0;
  FILE *source_fp, target_fp;
  FILE *debug_stream = stderr;

  if (argc < 9){
    fprintf(stderr,"usage:%s <src_host> <src_dir> <src_file> <dest_host> <dest_dir> <dest_file> <log_filename> <request_id> <log_message>",
	    argv[0]);
    exit(1);
  }

  strcpy(source_host, argv[1]);
  sprintf(source_file, "%s/%s", argv[2], argv[3]);
  strcpy(target_host, argv[4]);
  sprintf(target_file, "%s/%s", argv[5], argv[6]);
  strcpy(fname, argv[3]);
  strcpy(logfilename, argv[7]);  
  strcpy(request_id, argv[8]);
  strcpy(log_message, argv[9]);


  source = ftp_lite_open_and_auth(source_host,debug_stream);
  if(!source) {
    fprintf(stderr,"cannot connect to %s: %s\n",source_host,strerror(errno));
    exit(1);
  }

  target = ftp_lite_open_and_auth(target_host,debug_stream);
  if(!target) {
    fprintf(stderr,"cannot connect to %s: %s\n",target_host,strerror(errno));
    exit(1);
  }

  if(source&&target) {
    if (!ftp_lite_third_party_transfer(source,source_file,target,target_file))
      fprintf(stderr,"third party transfer failed: %s\n",strerror(errno));
    else write_log_basic(request_id ,fname, logfilename, log_message);
  }
    

}








