#include <stdio.h>
#include <stdlib.h>
#include "constants.h"
#include "condor_common.h"
#include "user_log.c++.h"
#include "reqex_server.h" //to be removed.............

#define BUF_SIZE 1024   

main(int argc, char *argv[])
{

  FILE *infile, *outfile;
  char infilename[MAXSTR], outfilename[MAXSTR];
  int nbytes;
  char *buf;

  // argv[1] = <infilename>
  if (argc != 2){
    dprintf(D_ALWAYS,"USAGE: %s <infilename>",argv[0]);
    exit(1);
  }

  buf = (char*)malloc(BUF_SIZE * sizeof(char));
  
  //open the input file : <infilename>

  sprintf(infilename,"%s/%s",SHARED_NEST_SPACE,argv[1]);
  //  sprintf(infilename,"%s",argv[1]);

  infile = fopen( infilename, "r" );

  if( infile == NULL ) {
    dprintf(D_ALWAYS,"ERROR: can't open input file %s\n", infilename);
    free(buf);
    exit( 1 );
  }

  //open the output file : <infilename.out>
  sprintf(outfilename,"%s.%s",infilename,"out");
  outfile = fopen( outfilename, "w" );
  if( outfile == NULL ) {
    dprintf(D_ALWAYS,"ERROR: can't open output file %s\n", outfilename);
    free(buf);
    exit( 1 );
  }

  while ( (nbytes = fread(buf, 1, BUF_SIZE,  infile)) > 0){
    fwrite(buf, nbytes, 1, outfile);
  }
  free(buf);
  fclose(infile);
  fclose(outfile);

}


