#include "reqex_nest_interface.h"

/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_SendNestFile(char *filename, NestConnection con)
{
  NestReplyStatus status = SendNestFile(filename, con);
  
  if ( status != NEST_SUCCESS )
    dprintf(D_ALWAYS,"NEST SendNestFile Error: %s\n", NestErrorString(status));
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_OpenNestConnection( NestConnection *con, char *nestlocation )
{
  NestReplyStatus status = OpenNestConnection( *con , nestlocation);
  
  if ( status != NEST_SUCCESS )
    dprintf(D_ALWAYS,"NEST OpenConnection Error: %s\n",NestErrorString(status));
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_WriteNestBytes( NestConnection con, char *remotefile, long offset, char *buffer, int size, bool ack_wanted )
{
  NestReplyStatus status = WriteNestBytes( con, remotefile, offset, buffer, size, ack_wanted );

  if ( status != NEST_SUCCESS ) 
    dprintf( D_ALWAYS, "NEST WriteBytes Error: %s\n", NestErrorString( status ) );
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_ReadNestBytes( NestConnection con, char *remotefile, long offset, char *buffer, int size, int *read_bytes)
{
  NestReplyStatus status = ReadNestBytes( con, remotefile, offset, buffer, size,  *read_bytes);
  
  if ( status != NEST_SUCCESS ) 
    dprintf( D_ALWAYS, "NEST ReadBytes Error: %s\n", NestErrorString( status ) );
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/

NestReplyStatus ReqEx_CloseNestConnection( NestConnection con )
{
  NestReplyStatus status = CloseNestConnection( con );

  if ( status != NEST_SUCCESS ) 
    dprintf( D_ALWAYS, "NEST CloseConnection Error: %s\n", NestErrorString( status ) );
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_NestFilesize ( long *filesize, char *remotefile, NestConnection con )
{
  NestReplyStatus status = NestFilesize ( *filesize, remotefile, con );

  if ( status != NEST_SUCCESS )
    dprintf( D_ALWAYS, "NEST FileSize Error: %s\n", NestErrorString( status ) );
  return status;
}
/* ==========================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_AvailableNestSpace( float *bytesavailable, NestConnection con)
{
  NestReplyStatus status = AvailableNestSpace(*bytesavailable, con);

  if ( status != NEST_SUCCESS )
    dprintf( D_ALWAYS, "NEST AvaliableNestSpace Error: %s\n", NestErrorString( status ) );
  return status;
}
/* ============================================================================
 *
 * ==========================================================================*/
extern "C" NestReplyStatus ReqEx_RemoveNestFile( char *remotefile, NestConnection con )
{
  NestReplyStatus status = RemoveNestFile(remotefile, con);

  if ( status != NEST_SUCCESS )
    dprintf( D_ALWAYS, "NEST RemoveNestFile Error: %s\n", NestErrorString( status ) );
  return status;
}

/* ============================================================================
 *
 * ==========================================================================*/
NestReplyStatus ReqEx_ReserveNestSpace ( long bytes_needed, char *filename, NestConnection con )
{
  NestReplyStatus status = ReserveNestSpace(bytes_needed, filename, con);

  if ( status != NEST_SUCCESS ) {
    dprintf(D_ALWAYS, "NEST ReserveSpace Error: %s\n",NestErrorString(status));
    return status;
  }	
}

