#ifndef _REQEX_NEST_INTERFACE_H_
#define _REQEX_NEST_INTERFACE_H_

#include "condor_common.h"
#include "condor_debug.h"
#include "../condor_daemon_core.V6/condor_daemon_core.h"
#include "constants.h"
#include "nest_speak.h"

extern "C" NestReplyStatus ReqEx_OpenNestConnection( NestConnection *con, char *nestlocation );
extern "C" NestReplyStatus ReqEx_CloseNestConnection( NestConnection con );

extern "C" NestReplyStatus ReqEx_SendNestFile(char *filename, NestConnection con);

extern "C" NestReplyStatus ReqEx_WriteNestBytes( NestConnection con, char *remotefile, long offset, char *buffer, int size, bool ack_wanted );

extern "C" NestReplyStatus ReqEx_ReadNestBytes( NestConnection con, char *remotefile, long offset, char *buffer, int size, int *bytes_read);

extern "C" NestReplyStatus ReqEx_AvailableNestSpace( float *bytesavailable, NestConnection con);

extern "C" NestReplyStatus ReqEx_NestFilesize ( long *filesize, char *remotefile, NestConnection con );

extern "C" NestReplyStatus ReqEx_ReserveNestSpace ( long bytes_needed, char *filename, NestConnection con);

extern "C" NestReplyStatus ReqEx_RemoveNestFile( char *remotefile, NestConnection con );

#endif




