#include "reqex_scheduler.h"
#include <stdlib.h>

/* ========================================================================
 * 
 * ======================================================================== */
void Scheduler::insert(char *request_id, long end_time, float req_size)
{
  Request *temp, *p;
  
  temp = (Request *)malloc(1 * sizeof(Request));

  strcpy(temp->request_id ,request_id);
  temp->end_time = end_time;
  temp->req_size = req_size;
  temp->next = NULL;

  if (head == NULL){
    head = temp;
  }
  else{
    p = head;
    if (p->end_time < end_time){
      while ( p->next != NULL && p->next->end_time < end_time){
	p = p->next;
      }
      if (p->next == NULL){
	p->next = temp;
      }
      else { //if p->next->duration >= duration
	temp->next = p->next;
	p->next = temp;
      }
    }//if
    else{
      temp->next = head;
      head = temp;
    }

  }//else
}
/* ========================================================================
 * 
 * ======================================================================== */
long Scheduler::schedule(float freespace, float new_request)
{
  Request *p;
  
  p = head;
  while (p != NULL){
    freespace += p->req_size;
    if (freespace >= new_request) break;
    else p = p->next;
  }
  
  if (p != NULL) return p->end_time;
  else return -1;
}
/* ========================================================================
 * 
 * ======================================================================== */
int Scheduler::remove(char *request_id)
{
  Request *p, *temp;
  
  p = head;
  
  if (p == NULL) return REQEX_ERROR;

  printf ("remove request:%s\n",request_id);

  if (!strcmp(request_id, p->request_id)){
    head = p->next;
    free(p);
    return p->end_time;
  }

  while (p->next != NULL){
    if (!strcmp(request_id, p->next->request_id)){
      temp = p->next;
      p->next = p->next->next;
      free(temp);
      return p->end_time;
    }
    p = p->next;
  }
  
  return -1;
    
}
/* ========================================================================
 * 
 * ======================================================================== */
void Scheduler::print()
{
  Request *p;
  
  p = head;
  while (p != NULL){
    printf("request_id:%s, end_time:%d, req_size:%f\n",
	   p->request_id, p->end_time, p->req_size);

      p = p->next;
  }
}




