#ifndef _CONDOR_SRB_REQEX_H
#define _CONDOR_SRB_REQEX_H

#include "condor_common.h"
#include "condor_string.h"
#include "condor_debug.h"
#include "basename.h"
#include "../condor_daemon_core.V6/condor_daemon_core.h"
#include "constants.h"


//--------------------------------------------------------------------------
typedef struct{
  int  pid;
  char filename[MAXSTR];
  long size;
  char location[MAXSTR];
}hashrec;

class file_hashtable
{
  int top;
  hashrec htable[MAXFILENUM];
  
 public:
  file_hashtable() {top=0;}
  ~file_hashtable() {}

  void   insert(int fid, char* filename, long size, char *location);
  char * get_filename(int pid);
  long   get_filesize(int pid);
  char * get_filelocation(int pid);

};

//--------------------------------------------------------------------------
typedef struct{
  char filename[MAXSTR];
  long size;
}progrec;

class progress_table{
  int top;
  int bottom;
  progrec ptable[MAXFILENUM];

 public:
  progress_table() {top = 0; bottom = 0;}
  ~progress_table() {}

  void insert(char *filename,long size);
  int  in_progress(char *filename);
  long deletef(char *filename);
  void check_progress(double & inprogress);

};
//--------------------------------------------------------------------------

void initializations();
int call_main();
void check_for_transfered_files();
void check_for_condor_logfiles();
void check_for_completed_jobs();
void check_for_completed_stage_outs();


int srb_transfer_reaper(Service *,int pid,int exit_status);
int send_condor_job_reaper(Service *,int pid,int exit_status);
int transfer_to_srb_reaper(Service *,int pid,int exit_status);
int transfer_to_NEST_reaper(Service *,int pid,int exit_status);

void dummy1();
#endif

