#include "condor_common.h"
#include "condor_string.h"
#include "condor_debug.h"
#include "basename.h"
#include "condor_md.h"
#include "dap_constants.h"

#define BUF_SIZE 1024

void reset(char *buffer)
{
  for (int i=0; i< BUF_SIZE;i++){
    buffer[i] = 0;
  } 
}


int main(int argc, char *argv[])
{
  FILE *fin;
  FILE *fout;
  
  
  char inbuffer[BUF_SIZE];
  unsigned char * outbuffer = (unsigned char *) malloc(MAC_SIZE);
  Condor_MD_MAC md5;

  if (argc < 3){
    fprintf(stderr, "=========================================================\n");
    fprintf(stderr, "USAGE: %s <infilename> <md5 filename\n", argv[0]);
    fprintf(stderr, "=========================================================\n");
    exit(-1);
  }

  //reset(inbuffer);
  
  fin = fopen(argv[1], "r");
  fout = fopen(argv[2], "w");

  int size;

  while ( (size = fread(inbuffer, 1, BUF_SIZE, fin)) > 0){
    if (size < BUF_SIZE) inbuffer[size] = '\0';
    
    memcpy(outbuffer, md5.computeOnce((unsigned char*)inbuffer, strlen(inbuffer)),
	    MAC_SIZE);
    fwrite(outbuffer, 1, MAC_SIZE, fout);
  }

  fclose(fin);
  fclose(fout);
  return 0;  
  
  //printf("ret : %d;in : %s; strlen: %d\n", size, inbuffer, strlen(inbuffer));
  //printf("md5 : %s\n", outbuffer);
  //-------- tests
  //passed = md5.verifyMD(outbuffer1, (unsigned char*)inbuffer1, strlen(inbuffer1));
  //printf("in1 vs out1 passed = %d\n",passed);
}
