#ifndef _DAP_SERVER_H
#define _DAP_SERVER_H

#include "condor_common.h"
#include "condor_string.h"
#include "condor_debug.h"
#include "basename.h"
#include "../condor_daemon_core.V6/condor_daemon_core.h"
#include "user_log.c++.h"
#include "dap_constants.h"


void initializations();
int call_main();
void startup_check_for_requests_in_process();
void regular_check_for_requests_in_process();
void regular_check_for_rescheduled_requests();

void listen_to_submit_requests();
void listen_to_status_requests();
void listen_to_remove_requests();
void accept_submit_requests();
void accept_status_requests();
void accept_remove_requests();



int submit_thread_reaper(Service *,int pid,int exit_status);
int status_thread_reaper(Service *,int pid,int exit_status);

int transfer_dap_reaper(Service *,int pid,int exit_status);
int reserve_dap_reaper(Service *,int pid,int exit_status);
int release_dap_reaper(Service *,int pid,int exit_status);



#endif

