#include "condor_common.h"
#include "dap_constants.h"
#include "dap_error.h"
#include "dap_utility.h"
#include "dap_logger.h"
#include <unistd.h>

int transfer_from_srm_to_srm(char *src_url, char *dest_url, char *arguments, 
			     char *error_str)
{

  string cc;
  
  FILE *pipe = 0, *outfile;
  char pipecommand[MAXSTR];
  char linebuf[MAXSTR];
  char cacheurl[MAXSTR], targeturl[MAXSTR];
  int ret;
  
  snprintf(pipecommand, MAXSTR, 
	   "%s/hrm-get.linux %s -s %s -t %s -b 0 -c %s/hrm.rc 2>&1| cat", 
	  LBNLSRM_BIN_DIR, arguments, src_url, dest_url, LBNLSRM_BIN_DIR);
  

  pipe = popen (pipecommand, "r");
  //pipe = popen ("/scratch/kosart/Condor_6_5_TRUNK_ALL/src/condor_data_manager/1", "r");
  if ( pipe == 0 ) {
    fprintf(stderr,"Error:couldn't open pipe to hrm-get.linux !\n");
    return -1;
  }

  /*
  while ( 1 ) {
    if ( fgets( linebuf, MAXSTR, pipe ) == 0 ) {
      break;
    }

    if (sscanf(linebuf, "HRM_GRIDFTP: file transfer completed from %s to %s",
	       cacheurl, targeturl ) > 0){
      if (!strcmp(targeturl, dest_url)){
	return DAP_SUCCESS;
      }
    }

    //fprintf(stdout, ">%s", linebuf);
  }
  */
  
  ret = pclose(pipe);
  fprintf(stdout, "Cammand terminated with err_code: %d\n", ret);
  
  if (ret == 0) 
    return DAP_SUCCESS;
  else {
    strncpy(error_str, linebuf, MAXSTR);
    return DAP_ERROR;
  }
  
}

int main(int argc, char *argv[])
{
  char src_url[MAXSTR], dest_url[MAXSTR], arguments[MAXSTR];
  int status;
  char error_str[MAXSTR];

  if (argc < 3){
    fprintf(stderr, "==============================================================\n");
    fprintf(stderr, "USAGE: %s <src_url> <dest_url> [<arguments>]\n", argv[0]);
    fprintf(stderr, "==============================================================\n");
    exit(-1);
  }

  strncpy(src_url, argv[1], MAXSTR);
  strncpy(dest_url, argv[2], MAXSTR);
  if (argc >= 4) strncpy(arguments, argv[3], MAXSTR); 
  else strncpy(arguments, "", MAXSTR);

  fprintf(stdout, "Transfering from: %s to: %s\n", src_url, dest_url);

  status = transfer_from_srm_to_srm(src_url, dest_url , arguments, error_str); 

  //-- output to a temporary file....
  if (status != DAP_SUCCESS){
    unsigned int mypid;
    FILE *f;
    char fname[MAXSTR];
    
    mypid = getpid();
    snprintf(fname, MAXSTR, "out.%d", mypid);

    f = fopen(fname, "w");
    fprintf(f, "SRM error: %s", error_str);
    fclose(f);  
  }
  //--

  return status;
}







