/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#ifndef __NETWORK_USAGE_H__
#define __NETWORK_USAGE_H__

#include "HashTable.h"
#include "classad_hashtable.h"

#define CONDOR_NETUSAGE_NUMBUCKETS 10

class NetworkUsage {
public:
	friend struct UsageRecord;

	NetworkUsage() : horizon(0), usage(255, hashFunction) {}
	~NetworkUsage() {}

	int SetHorizon(int seconds)
		{ int o = horizon; horizon = seconds; return o; }

		// return 0 on success and -1 on error
		// set and get usage in terms of seconds of network capacity
	int AddUsage(const char user[], unsigned int network, double seconds);
	int GetUsage(const char user[], unsigned int network, double &seconds);

	static const int numbuckets;

private:
		// The below used to be private, but for ease of porting
		// to Win32 due to scoping rule differences with respect to
		// nested classes between VC++ and GCC, they were made public.  
	int horizon;
	struct UsageRecord {
		UsageRecord(int *i);
		double Usage();
		void AddUsage(double seconds);
		void SetCurrentBucket(time_t current_time);
		int *horizon;
		int current_bucket;
		int current_bucket_time;
		double usage[CONDOR_NETUSAGE_NUMBUCKETS];
	};
	HashTable<HashKey, UsageRecord *> usage;
};

#endif
