/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#if !defined(_CARMI_H)
#define _CARMI_H

#if defined(__cplusplus)
extern "C" {
#endif

/* Get the req. id of the most recently received response msg. */
int carmi_retrieve_req_id( void );

int carmi_respawn(int, int);
/* Response: {int old_tid, int new_tid} */
int carmi_ckpt_on_vacate(int, int);
/* Response: {int success} */

int carmi_cancel_req(int, int);
/* Response: {int success} */

/* Checkpoint one task to a file, no network checkpoint */
int SimpleCkptTaskToFile(int tid, char *file, int response);

/* Restart a task from a checkpoint, return new tid */
int SimpleRestartTaskFromFile(char *a_out, char *arch, char *file, 
							  int response);
/* Response: int success, int new_tid */

/* Checkpoint a task to a file, system manages the file */
int SimpleCkptTask(int tid, int response);

/* Restart old task which had tid, return new tid system manages the file */
int SimpleRestartTask(int tid, int response);
/* Response: int success, int new_tid */

/* Migrate one task to a new host (user specified), no network checkpoint */
int SimpleMigrateTaskToHost(int tid, int host_tid, int response);

/* Migrate one task to a new host (system selected), no network checkpoint */
int SimpleMigrateTask(int tid, int response);
/* Response: int success, int new_tid */

/* Checkpoint the entire computation (including network state) to a file */
int CkptToFile(char *file, int response);

/* Restart a previously checkpointed computation */
int RestartFromFile(char *file, int response);

/* Checkpoint the computation */
int Ckpt();

/* Do a migration of a single task to a particular host tid remains the same */
int MigrateTaskToHost(int tid, int host_tid, int response);

/* Migrate a task to a system selected host */
int MigrateTask(int tid, int response);

/* A very general ckpting function, specify processes to ckpt, processes to
   maintain consistent tid space, and processes to simply flush the network */
int GeneralCkpt(int, int *, int, int *, int, int *, int);
/* Response: int success */

/* A very general ckpting function, specify processes to ckpt, processes to
   maintain consistent tid space, and processes to simply flush the network */
int GeneralCkptOnVacate(int, int *, int, int *, int, int *, int);
/* Response: int success */

#if defined(__cplusplus)
}
#endif
#endif
