/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#include "condor_common.h"
#include "condor_debug.h"
#include "fileno.h"
#include "condor_io.h"
#include "shadow.h"

FILE	*fdopen();

static int RSCSock;
static int LogSock;
extern int	PipeToParent;
extern int	LogPipe;
extern int	LockFd;
extern int	ImageSize;

extern int UsePipes;

static FILE *LogFP;

extern V2_PROC *Proc;

ReliSock *syscall_sock = NULL;

ReliSock *
RSC_ShadowInit( int rscsock, int errsock )
{
        RSCSock = rscsock;
        syscall_sock = new ReliSock();
        syscall_sock->attach_to_file_desc(RSCSock);

        syscall_sock->encode();

        LogSock = errsock;
        LogFP = fdopen(LogSock, "r");

        if( LogFP == NULL ) {
                EXCEPT("Cannot fdopen LogSock");
        }

        return( syscall_sock );
}

int
HandleLog()
{
	register char *nlp;
	char buf[ BUFSIZ ];

	for(;;) {
                memset(buf,0,sizeof(buf));

                errno = 0;
                if( fgets(buf, sizeof(buf), LogFP) == NULL ) {
                        dprintf( D_FULLDEBUG, "errno = %d\n", errno );
                        dprintf( D_FULLDEBUG, "buf = '%s'\n", buf);
                        return -1;
                }


                nlp = strchr(buf, '\n');
                if( nlp != NULL ) {
                        *nlp = '\0';
                }

                if ( buf[0] != '\0' ) {
                        dprintf(D_ALWAYS, "Read: %s\n", buf );
                }

                /*
                **      If there is more to read, read it, otherwise just
return
...
                */
#if defined(LINUX)
                if( LogFP->_IO_read_ptr == LogFP->_IO_read_end) {
                        return 0;
                }
#else
                if( LogFP->_cnt == 0 ) {
                        return 0;
                }
#endif
	}
}

/*
**	getppid normally returns the parents id, right?  Well in
**	the CONDOR case, this job may be started and checkpointed many
**	times.  The parent will change each time.  Instead we will
**	treat it as though the parent process died and this process
**	was inherited by init.
*/
int
condor_getppid()
{
	return( 1 );
}

/*
**	getpid should return the same number each time.  As indicated
**	above, this CONDOR job may be started and checkpointed several times
**	during its lifetime, we return the condor "process id".
*/
int
condor_getpid()
{
	extern V2_PROC *Proc;

	return( Proc->id.proc );
}
