/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#include "condor_classad.h"
typedef int (*FPTR)(int);

#if defined(__cplusplus)
        int pseudo_work_request( ClassAd *&ad, char *a_out, char *targ, 
					char *orig, int *kill_sig );
        int send_pvmd_job_info( ClassAd *&ad, char *a_out, char *targ,
				    char *orig, int *kill_sig, int host_num );
        int send_job_info( ClassAd *&ad, char *a_out, char *targ, char *orig,
                                    int *kill_sig, PROC *proc);
#endif

#if defined(__cplusplus)
extern "C" {
#endif
	/* from timer.c */
	int cancel_timer(int id);
	int new_timer(unsigned when, FPTR handler);

	/* from multi_shadow.C */
	void update_rusage ( register struct rusage *ru1, register struct rusage *ru2 );
        int mkargv ( int *argc, char *argv[], char *line );
        int PrintStartQueue( int debug_mask );
        void AddToStartQueue( int hostnum );
        char *d_format_time(double seconds);
        int initgroups(const char *owner, gid_t gid);
        void RemoveJob();
        int count_ready_hosts( int class_num );
        int multi_update_job_status( struct rusage *localp, struct rusage *remotep);
        void multi_handle_termination( int process_num,
                                        char *notification, char *coredir);
        void handle_termination( PROC *proc, char *notification,
                                        int *jobstatus, char *coredir );
        int StartWaitingHosts();
        int multi_get_client_ids( register PROC *proc, int process);
        int multi_start_job();
        int display_fd_set( int debug_level, char *string, fd_set *fdset,
                                                        int max_fd);
        int signal_startd( char *host, int cmd );
        int StartLocalProcess();
        int SendPVMStartAck();
        int multi_send_job( PROC *proc, int process, char *host);
        int multi_CleanupAll(int,int,char*);
        int multi_shadow( int argc, char    *argv[] );
        char    *gen_ckpt_name(char *, int, int, int);
        void sigalrm_handler(int);
        void HandleMsg();
        int HandleSchedd( int StdinIsAscii );
        void RemoveProc(int proc);
        void multi_HandleSyscalls(int process_num);
        void RemoveAllHosts();

	/* from joblist.C */
        int AllocProc();
        int InitJob( int cluster, int proc );
        int RemoveHost( int host_num );
        void AddToStartQueue( int hostnum );
        void RemoveProc(int proc);
        void RemoveAllHosts();
        int GetJobNum( int cluster, int proc );
        int PrintStartQueue( int debug_mask );
        int count_ready_hosts( int class_num );
        void req_exit_all();
        void RemoveJob();
        int NewHost( char *host, int class_num, char *addr_port,
                                                char *cap );

	/* from event.C */
        int host_timeout(int timer_id);
        int proc_start_timeout( int timer_id );
        void multi_HandleSyscalls(int process_num);
        void HandleCompletion();
        int HandleSchedd( int StdinIsAscii );
        void HandleMsg();
        int reschedule();

	/* from pvm_emulation.C */
        int     host_timeout(int);
        int     proc_start_timeout(int);
        int HandlePVM( int msg_tag, int src, int req_id );
#ifdef PVM34
        int DoSpawn(int for_whom, int req_id, char *a_out,
		char *arg_line, char *dest_arch, int where_flag,
		int out_tid, int out_ctx, int out_cod, 
		int trc_tid, int trc_ctx,
		int trc_cod, int response, int spawn_type);
#else
        int DoSpawn(int for_whom, int req_id, char *a_out,
                                char *arg_line, char *dest_arch, int where_flag,
                                int out_tid, int out_cod, int trc_tid,
                                int trc_cod, int response, int spawn_type);
#endif
	PROC *ConstructProc(int n_cmds, PROC *proc_template);
	void DestructProc(PROC    *proc);

	/* from carmi.C */
	int HandleCARMI( int msgtag, int msgtid, int req_id );
	int carmi_store_req_id(int req_id);
	int pseudo_get_file_stream( const char *file, size_t *len, 
				    unsigned int *ip_addr, u_short *port );

	/* from carmi_pseudo_ops.C */
        int pseudo_get_username( char *uname );
        int pseudo_suspended(int suspended);
        int pseudo_subproc_status(int subproc, int *statp,
                                        struct rusage *rusagep);
        int pseudo_pvm_info(char *pvmd_reply, int starter_tid);
        int pseudo_reallyexit( int *status, struct rusage *use_p );
        int pseudo_pvm_task_info(int pid, int task_tid);

	/* from classes.C */
        int PrintClass( int mask, ClassDef *classdef );
        ClassDef * NewClass(int new_num, char *name, char *requirements, 
							int min, int max, int current, ClassAd *thisad );
        int StoreClassDef(ClassDef *classdef, bool qmgmt_connected=false);
        int StoreAllClassDefs(bool qmgmt_connected=false);

	/* from co_check.C */
	int CoCheckCompleteCkpt(Process *dead_process);
	int HandleCoCheck( int msgtag, int msgtid, int req_id );

#if defined(__cplusplus)
}
#endif
