/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#if !defined(_REQUEST_H)
#define _REQUEST_H

#include "pvm3.h"
#include "joblist.h"

/* Request Types */
#define REQ_TASK_EXIT	(PvmTaskExit)
#define REQ_HOST_EXIT	(PvmHostDelete)
#define REQ_HOST_ADD	(PvmHostAdd)
#define REQ_HOST_SUSP	(PvmHostSuspend)
#define REQ_HOST_RESUME (PvmHostResume)
#define REQ_PVM_LAST	(REQ_HOST_RESUME)

#define REQ_SPAWN				(REQ_PVM_LAST + 2)
#define REQ_CKPT				(REQ_PVM_LAST + 3)
#define REQ_RESTART				(REQ_PVM_LAST + 4)
#define REQ_MIGRATE		 		(REQ_PVM_LAST + 5)
#define REQ_RJN_MSG				(REQ_PVM_LAST + 6)
#define REQ_CKPT_TASK_TO_FILE	(REQ_PVM_LAST + 7)
#define REQ_VACATE_NOTIFY		(REQ_PVM_LAST + 8)
#define REQ_CKPT_TASK			(REQ_PVM_LAST + 9)


typedef struct tagRequest {
	int		req_type;
	int		for_tid;
	int		on_tid;
	int		req_id;
	int		resp_msg;
	int		local_req_id;
	void	*extra_data;
	struct  tagRequest *next;
} Request;


typedef struct	tagWorkItem {
	PROC	*Proc;
	int		timer;
	char	*where;
	Process	*process;
	int		spawn_flag;
	int		spawn_type;
} WorkItem;

typedef struct {
	int		ckpt_cnt;
	int		*ckpt_list;
	int		consistent_cnt;
	int		*consistent_list;
	int		flush_cnt;
	int		*flush_list;
} GeneralCkptReq;


Request *NewRequest(int, int, int, int);
int		DeleteRequest(Request *);
Request *FindRequestByReqId(int);
Request *FindRequest(int, int, int, int);
Request *FindNextRequest(Request *, int, int, int, int);
int		SendResponse(Request *);
void	dprintf_request(int, Request *);
void	DumpRequestList( int );

#endif
