/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

 

#include "user_proc.h"

#define	TIDPVMD		0x80000000		/* Stolen from PVM's global.h */

class PVMdProc:public UserProc {
public:
	PVMdProc( ClassAd *ad, char *orig, char *targ, uid_t u, uid_t g, int id , int soft) : 
		UserProc(ad, orig, targ, u, g, id, soft) 
		{ ad->LookupInteger(ATTR_JOB_NOTIFICATION, my_shadow_tid); }
	void execute();
	void delete_files();
	void suspend() {}
	void resume() {}
private:
	int		my_shadow_tid;
};

class PVMUserProc:public UserProc {
public:
	PVMUserProc( ClassAd *ad, char *orig, char *targ, uid_t u, uid_t g, int id , int soft) : 
		UserProc(ad, orig, targ, u, g, id, soft) {}
	void execute();
	void request_ckpt();
/*	void send_sig( int ); */

	int		get_tid() { return pvm_tid; }
#if 0
	void	set_up_respawn(int, int, int);
	void	do_respawn();
	int		is_respawning() { return respawn_for_tid != 0; }
#endif
	void	set_checkpoint_on_vacate() { ckpt_wanted = 1; }
private:
	int		pvm_tid;
};
