#ifndef __DAGNODE_H_
#define __DAGNODE_H_

#include <set>
#include <stdio.h>
#include <string>

using namespace std;

/* This class defines a node in the dag which contains the 
   parentage information and its unique id */

typedef unsigned int NodeID; 

enum NodeType {
    NEST,
    DAG
};

class DagNode 
{
public:
    DagNode (NodeID nodeID, NodeType t = DAG); 
    ~DagNode();
    
    set <DagNode*> * GetParents() {return parents;}
    set <DagNode*> * GetChildren() {return children;}
    
    inline NodeID GetID () {return nodeID;}
    inline const char*  GetName() {return name;}
    void addParent(DagNode* node);
    void addChild (DagNode* node);
    void addRequirement (string requirement_string);
    void setNodeType (NodeType t) {type = t;}
    NodeType getNodeType () {return type;}
    
private:
    char * name; 
    NodeID nodeID;
    NodeType type;

    bool visited; 
    int DFSOrder; 
    
    set<DagNode*> * parents; 
    set<DagNode*> * children; 
    
    friend class DDag; 
    
    string req;

    string getRequirement();
    
    

};

#endif 
