/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

extern "C" void ckpt_and_exit();

class TestObj {
public:
	TestObj( const char * );
	void display();
	void setString( const char *str );
private:
	char	*string;
};

TestObj::TestObj( const char *init )
{
	string = new char[ strlen(init) + 1 ];
	assert( string );
	strcpy( string, init );
}

void
TestObj::setString( const char *str )
{
	delete [] string;
	string = new char[ strlen(str) + 1 ];
	assert( string );
	strcpy( string, str );
}

void
TestObj::display()
{
	printf( "\"%s\"\n", string );
}

TestObj MyObj( "Hello World" );

int
main()
{
	MyObj.display();
	MyObj.setString( "Goodby World" );

	ckpt_and_exit();

	MyObj.display();

	printf( "Normal End Of Job\n" );

	exit( 0 );
	return 0;
}
