/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-2001 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

 

/*
** This program makes sure getdirentries works
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#if defined(HPUX)
#include <ndir.h>
#else
#include <dirent.h>
#endif

#ifdef LINUX

// This appears to be the structure of a dent on Linux. Note that the
// wtf variable seems to not be documented.
// This works on Linux 2.2.19...
// Erik 9/2001
typedef struct kernel_dirent
  {
    long int d_ino;
    long d_off;
    unsigned short d_reclen;
	char wtf;
    char d_name[255];
  } DENT;

#elif defined(HPUX)
	typedef struct direct DENT;
#else
	typedef struct dirent DENT;
#endif

int main() {
/* HPUX should work, but it doesn't currently with the given code */
#if !defined(Solaris) && !defined( IRIX ) && !defined( HPUX )
	int results;
	off_t basep;
	int fd;
	char buf[8192];
	DENT *window;
	unsigned long voidstar;

	results = mkdir("testdir", 0777);	
	if(results == -1) {
		perror("mkdir");
		return -1;
	}

    // now let's create some files...
	fd = open("testdir/first", O_RDWR | O_CREAT);	
	if(fd < 0) { perror("Open First"); return -1; }
	close(fd);

	fd = open("testdir/second", O_RDWR | O_CREAT);	
	if(fd < 0) { perror("Open Second"); return -1; }
	close(fd);

	fd = open("testdir/third", O_RDWR | O_CREAT);	
	if(fd < 0) { perror("Open Third"); return -1; }
	close(fd);

	fd = open("testdir", O_RDONLY);	
	if(fd < 0) { perror("Open Directory"); return -1; }

	basep = 0;
#if defined(HPUX)
	results = getdirentries(fd, (DENT*)buf, 8192, &basep);
#else
	results = getdirentries(fd, buf, 8192, &basep);
#endif
	if(results < 0) {perror("getdirentries: "); return -1;}

	voidstar = (unsigned long int)buf;
	// Walk the list we got back from dirents	
	window = (DENT *)voidstar;
	while(window->d_reclen > 0) {
		printf("ENTRY: %s\n", window->d_name);	
		voidstar = voidstar + window->d_reclen;
		window = (DENT *)voidstar;
	}
	close(fd);
	
	fprintf(stdout, "completed successfully\n");
#endif
	return 0;
}
