/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#define _POSIX_SOURCE

#if defined(HPUX)
/*#include "condor_common.h"*/
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#else
#include "condor_common.h"
/*#include <stdio.h>*/
/*#include <fcntl.h>*/
/*#include <errno.h>*/
/*#include <stdlib.h>*/
/*#include <unistd.h>*/
/*#include <string.h>*/
#endif

#define FALSE 0
#define TRUE 1

int buf_eq( const char *buf1, const char *buf2, unsigned int size );

char	Hello[] = "Hello World\n";
char	Buf1[1024];
char	Buf2[1024] = "******************************";

main()
{
	int		rval;
	int		fd;

#undef WAIT_FOR_DEBUGGER
#if defined(WAIT_FOR_DEBUGGER)
	int		wait_up = 1;
	while( wait_up )
		;
#endif

	Buf1[0] = Buf2[0];

		/* Write "Hello World" to stdout */
	if( (rval=write(1,Hello,strlen(Hello))) < 0 ) {
		exit( __LINE__ );
	}

		/* Read line from stdin using read routine */
	if( (rval=read(0,Buf1,sizeof(Buf1))) < 0 ) {
		exit( __LINE__ );
	}
	if( lseek(0,0,0) < 0 ) {
		exit( __LINE__ );
	}

		/* Read line from stdin using stdio routine */
	if( fgets(Buf2,sizeof(Buf2),stdin) == NULL ) {
		exit( __LINE__ );
	}
	rewind( stdin );

		/* Check the buffers are equal */
	if( !buf_eq(Buf1,Buf2,rval) ) {
		exit( __LINE__ );
	}

		/* Read line from stdin using stdio routine */
	if( fgets(Buf1,sizeof(Buf1),stdin) == NULL ) {
		exit( __LINE__ );
	}
	rewind( stdin );

		/* Check the buffers are equal */
	if( !buf_eq(Buf1,Buf2,rval) ) {
		exit( __LINE__ );
	}

		/* Echo the line to stdout */
	if( (rval=write(1,Buf1,strlen(Buf1))) < 0 ) {
		exit( __LINE__ );
	}

		/* Create a file named "hello.results" */
	if( (fd=open("hello.results",O_WRONLY|O_CREAT|O_TRUNC,0664)) < 0 ) {
		exit( __LINE__ );
	}

		/* Write "Hello World" to "results" */
	if( (rval=write(fd,Hello,strlen(Hello))) < 0 ) {
		exit( __LINE__ );
	}

		/* Write "Goodby World" to stdout using stdio routine */
	printf( "Goodby World\n" );

		/* Write "Goodby World" to stderr using stdio routine */
	fprintf( stderr, "Goodby World\n" );

	printf( "Normal End Of Job\n" );

	exit( 0 );
}

int
buf_eq( const char *buf1, const char *buf2, unsigned int size )
{
	if( strlen(buf1) != size ) {
		return FALSE;
	}

	if( strlen(buf2) != size ) {
		return FALSE;
	}

	return memcmp( buf1, buf2, size ) == 0;
}
