/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
extern int errno;

main()
{
	int had_success = 0;

#if 0 /* God damned crap */

	if( acct( "/tmp" ) >= 0 ) {
		printf( "ERROR - acct() succeeded!\n" );
		had_success = 1;
	}

#if !defined(LINUX)
	if( adjtime( (struct timeval *)0, (struct timeval *)0 ) >= 0 ) {
		printf( "ERROR - adjtime() succeeded!\n" );
		had_success = 1;
	}
#endif

	if( chroot( "/tmp" ) >= 0 ) {
		printf( "ERROR - chroot() succeeded!\n" );
		had_success = 1;
	}

	if( fork() >= 0 ) {
		printf( "ERROR - fork() succeeded!\n" );
		had_success = 1;
	}

#if ! defined(LINUX)
	if( _fork() >= 0 ) {
		printf( "ERROR - _fork() succeeded!\n" );
		had_success = 1;
	}
#endif
		/* DUX has both _fork() and __fork() */
#if defined(LINUX) || defined(DUX)
	if( __fork() >= 0 ) {
		printf( "ERROR - __fork() succeeded!\n" );
		had_success = 1;
	}
#endif

#if !defined(IRIX)
	if( vfork() >= 0 ) {
		printf( "ERROR - vfork() succeeded!\n" );
		had_success = 1;
	}
#if defined(Solaris) || defined(HPUX)
	if( _vfork() >= 0 ) {
		printf( "ERROR - _vfork() succeeded!\n" );
		had_success = 1;
	}
#else /* LINUX || DUX */
	if( __vfork() >= 0 ) {
		printf( "ERROR - __vfork() succeeded!\n" );
		had_success = 1;
	}
#endif 
#endif /* ! IRIX */

#if defined(LINUX)
	if( bdflush( 0, 0 ) >= 0 ) {
		printf( "ERROR - bdflush() succeeded!\n" );
		had_success = 1;
	}
#endif

	if( had_success ) {
		printf( "Job failed\n" );
		exit( 1 );
	} else {
		printf( "Normal End Of Job\n" );
		exit( 0 );
	}

#endif
}
