/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

 


#include <sys/file.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>

#define NUMTESTS 500

#ifdef __cplusplus
extern "C" {
#endif

extern void ckpt_and_exit();
void loop(){};

int main( int argc, char **argv )
{
	int i, j;
	register int k;
	char buf[ 1024 ];
	FILE	*fp;
	void *curbrk, *oldbrk;

	/*
	DebugFlags = D_CKPT;
	*/

	if( (fp=fopen( "printer.results", "w" )) == NULL ) {
		perror( "printer.results" );
		exit( 1 );
	}

	oldbrk = sbrk(0);

	for( i = 0; i < NUMTESTS; i++ ) {
		sprintf(buf, "set i = %d\n", i);
		if (write(2, buf, strlen(buf)) == -1)
		{
			printf("WHAT?!? Write failed on fd[%d]\n", fileno(fp));
			exit(EXIT_FAILURE);
		}

		rewind( fp );
		if (fprintf( fp, "set i = %d\n", i ) == -1)
		{
				printf("WHAT?!? fprintf failed on fd[%d]\n", fileno(fp));
				exit(EXIT_FAILURE);
		}
		fflush( fp );

		curbrk = sbrk(0);
		if( oldbrk != curbrk ) {
			printf("Current break is now 0x%x, old was 0x%x (set i = %d)\n",
				curbrk, oldbrk, i);
		}

		oldbrk = curbrk;

		for(k=j=0; j < 100000; k++,j++ );
		if( j != k ) {
			sprintf(buf, "j = %d, k (register) = %d\n", j, k);
			if (write(2, buf, strlen(buf)) == -1)
			{
				printf("WHAT?!? Write failed on fd[%d]\n", fileno(fp));
				exit(EXIT_FAILURE);
			}
		}

		ckpt_and_exit();
	}
	fclose(fp);
	exit( 0 );
}

#ifdef __cplusplus
}
#endif
