/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-1998 CONDOR Team, Computer Sciences Department, 
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.  
 * No use of the CONDOR Software Program Source Code is authorized 
 * without the express consent of the CONDOR Team.  For more information 
 * contact: CONDOR Team, Attention: Professor Miron Livny, 
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685, 
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure 
 * by the U.S. Government is subject to restrictions as set forth in 
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer 
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and 
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR 
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron 
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison, 
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#define _POSIX_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <assert.h>

void ThreadExecute( void (*func)() );
void ThreadReturn();
void func();
void loop( int n );
void check_buf( char *buf, char fill_char, size_t size );
void fill_buf( char *buf, char fill_char, size_t size );
extern "C" void ckpt_and_exit();

main( int argc, char *argv[] )
{
	int		i;
	char	buf[ 1024 * 1024 ];
	char	fill_char = 'a';

	for( i = 0; i<10; i++, fill_char++ ) {
		printf( "i = %d\n", i );
		printf( "This should be a STACK address 0x%p\n", &i );
		fflush( stdout );
		fill_buf( buf, fill_char, sizeof(buf) );

		printf( "About to Ckpt from STACK\n" );
		fflush( stdout );
		ckpt_and_exit();
		printf( "Returned from ckpt_and_exit\n" );
		fflush( stdout );

		loop( 1 );
		ThreadExecute( func );
		check_buf( buf, fill_char, sizeof(buf) );
	}
	printf( "Normal End_Of_Job\n" );
	exit( 0 );
}

void
fill_buf( char *buf, char fill_char, size_t size )
{
	int		i;

	for( i=0; i<size; i++ ) {
		buf[i] = fill_char;
	}
}

void
check_buf( char *buf, char fill_char, size_t size )
{
	int		i;

	for( i=0; i<size; i++ ) {
		assert( buf[i] == fill_char );
	}
}

void
func()
{
	int		i;

	printf( "This should be a DATA address 0x%p\n", &i );
	fflush( stdout );

	printf( "About to Ckpt from DATA\n" );
	fflush( stdout );
	ckpt_and_exit();
	printf( "Returned from ckpt_and_exit\n" );
	fflush( stdout );

	loop( 2 );
	ThreadReturn();
}

#undef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0

/* IRIX can use 64 bit numbers for the elements if the jump buf, while 
	long is defined to be 32 bits. */
#if defined(IRIX)
#define JMP_BUF_SP(env) (((env))[JMP_BUF_SP_INDEX])
#else
#define JMP_BUF_SP(env) (((long *)(env))[JMP_BUF_SP_INDEX])
#endif


#if defined(ULTRIX43)
#	define SETJMP _setjmp
#	define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 32

#elif defined(SUNOS41)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 2

#elif defined(SOLARIS2) || defined(Solaris)
#   define SETJMP setjmp
#   define LONGJMP longjmp
#	define StackGrowsDown TRUE
#if defined(X86)
#	define JMP_BUF_SP_INDEX 4
#else
#	define JMP_BUF_SP_INDEX 1
#endif

#elif defined(OSF1)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 34

#elif defined(HPUX)
#   define SETJMP setjmp
#   define LONGJMP longjmp
#	define StackGrowsDown FALSE
#	define JMP_BUF_SP_INDEX 1

#elif defined(AIX32)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 3

#elif defined(HPUX)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown FALSE
#	define JMP_BUF_SP_INDEX 1

#elif defined(LINUX)
#   define StackGrowsDown TRUE
#   define JMP_BUF_SP_INDEX 4
#   define SETJMP setjmp
#   define LONGJMP longjmp

#elif defined(IRIX62)
#	define SETJMP setjmp
#	define LONGJMP longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 39

#elif defined(IRIX65)
#	define SETJMP setjmp
#	define LONGJMP longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 34

#else
#   error UNKNOWN PLATFORM
#endif

/*
  Switch to a temporary stack area in the DATA segment, then execute the
  given function.  Note: we save the address of the function in a
  global data location - referencing a value on the stack after the SP
  is moved would be an error.
*/
static void (*SaveFunc)();
static jmp_buf ReturnEnv;

// The stack is to be aligned on an 8-byte boundary on some
// machines. This is required so that double's can be pushed
// on the stack without any alignment problems.

// Solaris seems to push some really large stack frames on during
// checkpoint....  -Jim B.
// Lately, we had added lots of code to the checkpointing process so this
// variable needs to be bigger on some platforms. I figure I'll make it
// "big enough". :) -psilord
const int	TmpStackSize = (sizeof(char)*524288)/sizeof(double);
static double	TmpStack[ TmpStackSize ];

void
ThreadExecute( void (*func)() )
{
	jmp_buf	env;
	SaveFunc = func;

	if( SETJMP(ReturnEnv) == 0 ) {
		if( SETJMP(env) == 0 ) {
				// First time through - move SP
			if( StackGrowsDown ) {
				JMP_BUF_SP(env) = (long)(TmpStack + TmpStackSize - 2);
			} else {
				JMP_BUF_SP(env) = (long)TmpStack;
			}
			LONGJMP( env, 1 );
		} else {
				// Second time through - call the function
			SaveFunc();
		}
	} else {
		return;
	}
}

void
ThreadReturn()
{
	LONGJMP( ReturnEnv, 1 );
}

#define UNIT 10000

#if defined(ALPHA)
#	define LIM (800 * UNIT)
#elif defined(AIX32)
#	define LIM (225 * UNIT)
#elif defined(SPARC) || defined(Solaris)
#	define LIM (260 * UNIT)
#elif defined(ULTRIX43)
#	define LIM (170 * UNIT)
#elif defined(HPPAR)
#	define LIM (260 * UNIT)
#elif defined(LINUX)
#	define LIM (100 * UNIT)
#elif defined(IRIX)
#	define LIM (800 * UNIT)
#else
#	error UNKNOWN PLATFORM!!!
#endif

void waste_a_second()
{
	int		i;

	for( i=0; i<LIM; i++ )
		;
}

void
loop( int n )
{
	int		i;

	for( i=0; i<n; i++ ) {
		waste_a_second();
	}

}
