
import java.io.*;
import edu.wisc.cs.condor.chirp.*;

public class TestChirp {

	public static void main( String args[] ) {

		if( args.length!=2 ) {
			System.err.println("use: TestChirp <infile> <outfile>\n");
			System.exit(1);
		}

		String tempname = args[1]+".tmp";

		try {
			String line;

			BufferedReader in = new BufferedReader(new InputStreamReader(new ChirpInputStream(args[0])));
			PrintWriter out = new PrintWriter(new OutputStreamWriter(new ChirpOutputStream(tempname)));

			while(true) {
				line = in.readLine();
				if(line==null) break;
				out.println(line);
			}

			out.close();

			ChirpClient c = new ChirpClient();
			c.rename(tempname,args[1]);

			System.out.println("done!");

		} catch( IOException e ) {
			System.out.println(e);
		}
	}
}
