
import java.io.*;
import java.util.*;
import edu.wisc.cs.condor.chirp.*;

public class TestChirpSpeed {

	private final static int MEGA = 1024*1024;
	private final static int SIZE = 100*MEGA;
	private final static int BUFSIZE = MEGA;

	public static void main( String args[] ) {

		if(args.length!=1) {
			System.err.println("use: TestChirpSpeed <file>");
			System.exit(1);
		}

		byte [] buffer = new byte[BUFSIZE];
		int total = 0;

		for( int i=0; i<BUFSIZE; i++ ) {
			buffer[i] = (byte)i;
		}

		try {	
			total = 0;
			Date writeStart = new Date();
			ChirpOutputStream out = new ChirpOutputStream(args[0]);
			while(total<SIZE) {
				out.write(buffer,0,BUFSIZE);
				total += BUFSIZE;
			}
			out.close();
			Date writeEnd = new Date();

			long writeMillis = writeEnd.getTime() - writeStart.getTime();
			System.out.println("write speed: "+SIZE+" bytes in "+writeMillis+" ms, "+(double)SIZE/writeMillis+" KB/s");

			total = 0;
			Date readStart = new Date();
			ChirpInputStream in = new ChirpInputStream(args[0]);
			while(total<SIZE) {
				in.read(buffer,0,BUFSIZE);
				total += BUFSIZE;
			}
			in.close();
			Date readEnd = new Date();

			long readMillis = readEnd.getTime() - readStart.getTime();
			System.out.println("read speed: "+SIZE+" bytes in "+readMillis+" ms, "+(double)SIZE/readMillis+" KB/s");


			
		} catch( IOException e ) {
			System.out.println(e);
		}
	}
}


