#if !defined( GANGSTER_H )
#define GANGSTER_H

#define EXPERIMENTAL

#include <map>
#include "condor_classad.h"
#include "gmr.h"

class QueryProcessor;

class Gangster {
public:
	Gangster( Gangster*, int );
	virtual ~Gangster( );

	bool assign(QueryProcessor*, GMR*,int,const References&,const References&, 
				KeySet &);
	bool setupMatchBindings( int );
	void teardownMatchBindings( int );
	bool match(QueryProcessor*, const References&, const References&, bool);
	void retire( QueryProcessor*, bool=false );
	void reset( QueryProcessor* );
	void printKeys( );
	void printStats( );

	enum { 
		LEFT_RIGHT, 
		RIGHT_LEFT, 
		DYNAMIC, 
		LEFT_RIGHT_CHECKED, 
		RIGHT_LEFT_CHECKED 
	};

	static double overhead;
	static int    numMatchesTested;
	static int    algorithm;

	static set<int>		keysInBundle;

	void testMatch( int, Value& );
	bool fillDock( QueryProcessor*, const References&, const References&,
				int, bool );

	struct Dock {
		GMR::Port			*port;
		int					lastSKey, lastRKey, lastPKey, lastPNum, lastCKey;
		int					numFillAttempts, numCandidates;
		int					offset;
		bool				queried;
		KeySet				matchResult;
		KeySet::iterator	ksitr;
		Gangster			*boundGangster;
		int					boundDock;
		bool				satisfied;
		bool				filled;
		set<int>			deps, rdeps, rdepsTC;
	};
	typedef vector<Dock> Docks;

	vector<int>			dockOrder;

	static int			nextContextNum;

	GMR					*gmr;
	Gangster 			*parentGangster;
	int					parentDockNum;
	ClassAd				*context;
	int					contextNum;
	int					parentLinked;
	Docks				docks;
};


#endif
