#if !defined( GMR_H )
#define GMR_H

#define EXPERIMENTAL

#include "condor_classad.h"
#include <set>

class GMR {
public:
    GMR( );
    ~GMR( );

    typedef set<int> Dependencies;

    struct Port {
        string          label;
        ClassAd         *portAd;
        Dependencies    dependencies;
    };
    typedef vector<Port> Ports;

    ClassAd             *parentAd;
    int                 key;
    Ports               ports;

    static GMR *MakeGMR( int, ClassAd * );
    void Display( FILE * = stdout );
    bool GetExternalReferences( References &refs );
    bool AddRectangles( Rectangles& );
    bool AddRectangles( int port, Rectangles& );
	bool AddRectangles( int oPort, int dPort, Rectangles& ); 
};

typedef multimap<int,ClassAd*> ClassAdMap;
typedef map<int,GMR*> GMRMap;

#endif
