#include "condor_common.h"
#include "gmr.h"

//-----------------------------------------------------------------------------
//  util function(s)

int 
loadClassAds( const char *filename, GMRMap &gmrs )
{
    FILE    		*fp;
    char    		buffer[10240];
    ClassAd 		*ad;
    int     		key;
    int     		tmp=0;
	GMR				*gmr;
	ClassAdParser	parser;

    if( !( fp=fopen( filename, "r" ) ) ) {
        printf( "Failed to open file %s\n", filename );
        exit( 1 );
    }

        // load up classads from file
    while( 1 ) {
        if( fscanf( fp, "%d", &key ) != 1 ) {
            if( !feof( fp ) ) {
                printf( "Failed to read key\n" );
                exit( 1 );
            } else {
                fclose( fp );
                return( tmp );
            }
        }
        if( fgets( buffer, 10240, fp ) == NULL ) {
            printf( "Error reading classad with key %d\n", key );
            exit( 1 );
        }

        if( !( ad = parser.ParseClassAd( buffer ) ) ) {
            printf( "Parse error on %s: %s\n", buffer, 
                CondorErrMsg.c_str( ) );
            exit( 1 );
        }

		
		if( !( gmr = GMR::MakeGMR( key, ad ) ) ) {
			printf( "Failed to make GMR on %s\n", buffer );
			exit( 1 );
		}

            // insert gmr into map
        gmrs[key] = gmr; 


        tmp++;
    }

        // won't reach here --- for c++
    return( -1 );   
}
