#ifndef _MYAPP_DRIVER_H
#define _MYAPP_DRIVER_H

#include "MWDriver.h"
#include "Task_MYAPP.h"

/** Application Driver subclass derived from MWDriver */

class Driver_MYAPP : public MWDriver 
{
public:
       	Driver_MYAPP();
       	~Driver_MYAPP();

	/* Get the info from the user.  Don't forget to get the worker_executable! */
       	MWReturn get_userinfo( int argc, char *argv[] );

	/* Set up an array of tasks here */
       	MWReturn setup_initial_tasks( int *, MWTask *** );

	/* What to do when a task finishes */
       	MWReturn act_on_completed_task( MWTask * );

	/* Put things in the send buffer here that go to a worker */
       	MWReturn pack_worker_init_data( void );

	/* OK, this one doesn't *have* to be...but you want to be able to
	 * tell the world the results, don't you? :-) */
       	void printresults();

	/* Write out the state of the master to a file. */
       	void write_master_state( FILE *fp );

	/* Read in the state from a file. */
       	void read_master_state( FILE *fp );

	/* Just return a newly constructed application task */
       	MWTask* gimme_a_task();

private:  /* You application specific information goes here! */
	
	/* In this example, MW wants to find out the largest integer 
	 * from a group of integers. Each worker get some of the integers, 
	 * and tells the master the largest among them, the master will 
	 * pick the largest among the results. */
       	int num_tasks;	/* how many tasks I've generated */
       	int remain;	/* only use for task generation */
       	int job_size; 	/* how many int I have */
       	int task_size;	/* number of integers per task */
       	int *job;	/* All the integers */
       	int largest;	/* the finial result */
};

#endif
